#include "procs"

static editCmd viewCmdTable [] = { 	/* define standard command set */
  {ctrl('f'), right},          		/* cursor right */
  {ctrl('b'), left},           		/* cursor left  */
  {ctrl('n'), dwncol},     		/* down in column */
  {ctrl('p'), upcol},     		/* up in column */
  {ctrl('a'), beglin},     		/* beginning of line */
  {ctrl('e'), endlin},     		/* end of line */
  {ctrl('v'), uppage},       		/* forward page */
  {ctrl('l'), newscr},               	/* redraw screen */
  {ctrl('s'), fsearch},			/* search forward */
  {ctrl('r'), bwsearch},		/* search backward */
  {EOS,     (int (*)()) 0},		/* end of list */
};		

static editCmd editCmdTable [] = { 	/* define standard command set */
  {ctrl('a'), beglin},     		/* beginning of line */
  {ctrl('b'), left},          		/* cursor left  */
  {ctrl('d'), delnxt},	        	/* delete next character */
  {ctrl('e'), endlin},     		/* end of line */
  {ctrl('f'), right},          		/* cursor right */
  {ctrl('j'), newline},                 /* insert carriage return */
  {ctrl('k'), krest},			/* delete to end of line */
  {ctrl('l'), newscr},               	/* redraw screen */
  {ctrl('m'), newline},                 /* insert carriage return */
  {ctrl('n'), dwncol},     		/* down in column */
  {ctrl('o'), openln},	        	/* open line above */
  {ctrl('p'), upcol},     		/* up in column */
  {ctrl('r'), bwsearch},		/* search backward */
  {ctrl('s'), fsearch},			/* search forward */
  {ctrl('v'), uppage},       		/* forward page */
  {ctrl('w'), cut},			/* cut region into kill buffer */
  {ctrl('y'), yank},       		/* yank killbuffer */
  {127,       delprev},            	/* delete previous char */
  {EOS,     (int (*)()) 0},		/* end of list */
};		

static editCmd ctrlXCmds [] = {	
  {ctrl('c'), editAbort},		/* abort editor */
  {ctrl('d'), dot},			/* set dot to current position */
  {ctrl('f'), findFile},		/* read in alternate file */
  {ctrl('i'), insertFile},		/* insert named file into buffer */
  {ctrl('k'), clearBuffer},		/* kill the current buffer */
  {ctrl('m'), exMark},			/* set mark to current position */
  {ctrl('s'), saveFile},		/* save buffer to current file */
  {ctrl('w'), writeFile},		/* write buffer to named file */
  {ctrl('x'), exchangeDotMark},		/* exchange dot and mark */
  {'c', editExit},			/* leave editor */
  {'k', killBuffer},			/* clear the current buffer */
  {'o', openlnd},	        	/* open line below */
  {'t', lineToTop},			/* current line to top of screen */
  {'?', help},				/* display help information */
  {EOS, (int (*)()) 0},
};

static editCmd viewEscCmds [] = {
  {'<', topBuffer},			/* goto top of file */
  {'>', botBuffer},			/* goto bottom of file */
  {' ', goLine},			/* goto specified line */
  {'=', memory},			/* display statistics */
  {'?', whatLine},			/* display current line number */
  {'b', wordl},				/* move to left word */
  {'f', wordr},				/* move to right word */
  {'h', topscr},			/* cursor to top of display */
  {'l', botscr},			/* cursor to last line of display */
  {'m', midscr},			/* cursor near middle of display */
  {'n', upScroll},			/* scroll up */
  {'p', dwnScroll},			/* scroll down */
  {'r', bbsearch},			/* continue search backword */
  {'s', ffsearch},			/* continue search forward */
  {'v', dwnpage},			/* display previous page */
  {EOS, (int (*)()) 0},
};

static editCmd editEscCmds [] = {
  {'<', topBuffer},			/* goto top of file */
  {'>', botBuffer},			/* goto bottom of file */
  {' ', goLine},			/* goto specified line */
  {'=', memory},			/* display statistics */
  {'b', wordl},				/* move to left word */
  {'d', fdelword},			/* delete next word */
  {'f', wordr},				/* move to right word */
  {'h', topscr},			/* cursor to top of display */
  {'l', botscr},			/* cursor to last line of display */
  {'m', midscr},			/* cursor near middle of display */
  {'n', upScroll},			/* scroll up */
  {'p', dwnScroll},			/* scroll down */
  {'r', bbsearch},			/* continue search backword */
  {'s', ffsearch},			/* continue search forward */
  {'v', dwnpage},			/* display previous page */
  {'w', copy},				/* copy region to kill buffer */
  {'?', whatLine},			/* display current line number */
  {127, bdelword},			/* delete previous word */
  {ctrl('w'), fdelword},		/* delete next word */
  {ctrl('x'), resetRegion},		/* display region not inverted */
  {EOS, (int (*)()) 0},
};
